searchData={"items":[{"type":"module","title":"Taxo","doc":"Taxo is an Elixir port of the Clojure hierarchies provided by `derive` and `underive`.","ref":"Taxo.html"},{"type":"function","title":"Taxo.ancestors/2","doc":"Returns the ancestors of a given `child` in the taxonomy `taxo`.","ref":"Taxo.html#ancestors/2"},{"type":"function","title":"Examples - Taxo.ancestors/2","doc":"iex> Taxo.new |> Taxo.derive(:monkey, :mammal) |> Taxo.ancestors(:monkey)\n      MapSet.new([:mammal])","ref":"Taxo.html#ancestors/2-examples"},{"type":"function","title":"Taxo.derive/3","doc":"Establish a parent/child relationship in `taxo` between `child` and `parent`.\nUpdates `:parents`, then transitively updates `:ancestors` and `:descendants`.","ref":"Taxo.html#derive/3"},{"type":"function","title":"Examples - Taxo.derive/3","doc":"iex> Taxo.new |> Taxo.derive(:monkey, :mammal)\n    %Taxo{\n      ancestors: %{monkey: MapSet.new([:mammal])},\n      parents: %{monkey: MapSet.new([:mammal])},\n      descendants: %{mammal: MapSet.new([:monkey])}\n    }","ref":"Taxo.html#derive/3-examples"},{"type":"function","title":"Taxo.descendants/2","doc":"Returns the descendants of a given `child` in the taxonomy `taxo`.","ref":"Taxo.html#descendants/2"},{"type":"function","title":"Examples - Taxo.descendants/2","doc":"iex> Taxo.new |> Taxo.derive(:monkey, :mammal) |> Taxo.descendants(:mammal)\n      MapSet.new([:monkey])","ref":"Taxo.html#descendants/2-examples"},{"type":"function","title":"Taxo.is_a?/3","doc":"Returns true if (= child parent), or child is directly or indirectly derived from parent.","ref":"Taxo.html#is_a?/3"},{"type":"function","title":"Examples - Taxo.is_a?/3","doc":"iex> Taxo.new |> Taxo.derive(:monkey, :mammal) |> Taxo.derive(:mammal, :vertebrate) |> Taxo.is_a?(:monkey, :vertebrate)\n    true\n\n    iex> Taxo.new |> Taxo.derive(:monkey, :mammal) |> Taxo.derive(:mammal, :vertebrate) |> Taxo.is_a?(:vertebrate, :monkey)\n    false","ref":"Taxo.html#is_a?/3-examples"},{"type":"function","title":"Taxo.new/0","doc":"Create a new taxonomy to store the `:parents`, `:ancestors` and `:descendants` of\nparent/child relationships, updated via `derive` and `underive`.\nUpdates `:parents`, then transitively updates `:ancestors` and `:descendants`.","ref":"Taxo.html#new/0"},{"type":"function","title":"Examples - Taxo.new/0","doc":"iex> Taxo.new\n    %Taxo{ancestors: %{}, parents: %{}, descendants: %{}}","ref":"Taxo.html#new/0-examples"},{"type":"function","title":"Taxo.parents/2","doc":"Returns the parents of a given `child` in the taxonomy `taxo`.","ref":"Taxo.html#parents/2"},{"type":"function","title":"Examples - Taxo.parents/2","doc":"iex> Taxo.new |> Taxo.derive(:monkey, :mammal) |> Taxo.parents(:monkey)\n      MapSet.new([:mammal])","ref":"Taxo.html#parents/2-examples"},{"type":"function","title":"Taxo.underive/3","doc":"Removes a parent/child relationship in `taxo` between `child` and `parent`.\nUpdates `:parents`, then transitively updates `:ancestors` and `:descendants`.","ref":"Taxo.html#underive/3"},{"type":"function","title":"Examples - Taxo.underive/3","doc":"iex> Taxo.derive(%{}, :monkey, :mammal) |> Taxo.underive(:monkey, :mammal)\n    %Taxo{ancestors: %{}, parents: %{}, descendants: %{}}","ref":"Taxo.html#underive/3-examples"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.3"}}